// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from gazebo_model_attachment_plugin_msgs:srv/Detach.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_MODEL_ATTACHMENT_PLUGIN_MSGS__SRV__DETAIL__DETACH__STRUCT_HPP_
#define GAZEBO_MODEL_ATTACHMENT_PLUGIN_MSGS__SRV__DETAIL__DETACH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__gazebo_model_attachment_plugin_msgs__srv__Detach_Request __attribute__((deprecated))
#else
# define DEPRECATED__gazebo_model_attachment_plugin_msgs__srv__Detach_Request __declspec(deprecated)
#endif

namespace gazebo_model_attachment_plugin_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Detach_Request_
{
  using Type = Detach_Request_<ContainerAllocator>;

  explicit Detach_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->joint_name = "";
      this->model_name_1 = "";
      this->model_name_2 = "";
    }
  }

  explicit Detach_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : joint_name(_alloc),
    model_name_1(_alloc),
    model_name_2(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->joint_name = "";
      this->model_name_1 = "";
      this->model_name_2 = "";
    }
  }

  // field types and members
  using _joint_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _joint_name_type joint_name;
  using _model_name_1_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _model_name_1_type model_name_1;
  using _model_name_2_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _model_name_2_type model_name_2;

  // setters for named parameter idiom
  Type & set__joint_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->joint_name = _arg;
    return *this;
  }
  Type & set__model_name_1(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->model_name_1 = _arg;
    return *this;
  }
  Type & set__model_name_2(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->model_name_2 = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__gazebo_model_attachment_plugin_msgs__srv__Detach_Request
    std::shared_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__gazebo_model_attachment_plugin_msgs__srv__Detach_Request
    std::shared_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Detach_Request_ & other) const
  {
    if (this->joint_name != other.joint_name) {
      return false;
    }
    if (this->model_name_1 != other.model_name_1) {
      return false;
    }
    if (this->model_name_2 != other.model_name_2) {
      return false;
    }
    return true;
  }
  bool operator!=(const Detach_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Detach_Request_

// alias to use template instance with default allocator
using Detach_Request =
  gazebo_model_attachment_plugin_msgs::srv::Detach_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace gazebo_model_attachment_plugin_msgs


#ifndef _WIN32
# define DEPRECATED__gazebo_model_attachment_plugin_msgs__srv__Detach_Response __attribute__((deprecated))
#else
# define DEPRECATED__gazebo_model_attachment_plugin_msgs__srv__Detach_Response __declspec(deprecated)
#endif

namespace gazebo_model_attachment_plugin_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Detach_Response_
{
  using Type = Detach_Response_<ContainerAllocator>;

  explicit Detach_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  explicit Detach_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__gazebo_model_attachment_plugin_msgs__srv__Detach_Response
    std::shared_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__gazebo_model_attachment_plugin_msgs__srv__Detach_Response
    std::shared_ptr<gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Detach_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const Detach_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Detach_Response_

// alias to use template instance with default allocator
using Detach_Response =
  gazebo_model_attachment_plugin_msgs::srv::Detach_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace gazebo_model_attachment_plugin_msgs

namespace gazebo_model_attachment_plugin_msgs
{

namespace srv
{

struct Detach
{
  using Request = gazebo_model_attachment_plugin_msgs::srv::Detach_Request;
  using Response = gazebo_model_attachment_plugin_msgs::srv::Detach_Response;
};

}  // namespace srv

}  // namespace gazebo_model_attachment_plugin_msgs

#endif  // GAZEBO_MODEL_ATTACHMENT_PLUGIN_MSGS__SRV__DETAIL__DETACH__STRUCT_HPP_
